diff --git a/src/pisyntax.ml b/src/pisyntax.ml
index a3111ae..ade81e5 100644
--- a/src/pisyntax.ml
+++ b/src/pisyntax.ml
@@ -99,13 +99,23 @@ let check_fun_decl is_tuple (name,ext) arity is_private =
       f_private = is_private;
       f_options = 0 }
 
+(* Environment of a process.
+   May contain function symbols, names and variables.
+   Is a map from strings to the description of the ident *)
+
+type envElement = EFun of funsymb
+                | EVar of binder
+                | EName of funsymb
+
 let get_var env s =
   try 
-    Hashtbl.find env s
+    match (Hashtbl.find env s) with
+        EVar x -> Var x
+      | EName f -> FunApp(f, [])
   with Not_found -> 
     let r = Terms.new_var s Param.any_type in
-    Hashtbl.add env s r;
-    r
+    Hashtbl.add env s (EVar r);
+    Var r
 
 let get_fun (s,ext) arity =
   try
@@ -144,7 +154,7 @@ let rec check_eq_term f_allowed varenv (term,ext) =
 	  f_allowed f ext;
 	  FunApp(f, [])
 	with
-	  Not_found -> Var (get_var varenv s)
+	  Not_found -> get_var varenv s
       end
   | (PFunApp (fi, tlist)) ->
       let f = get_fun fi (List.length tlist) in
@@ -291,16 +301,6 @@ let check_clause = function
       Rules.add_equiv (hyp, concl, -1); (* TO DO should give a real rule number, but that's not easy... *)
       if not select then Terms.add_unsel concl
 
-      
-
-(* Environment of a process.
-   May contain function symbols, names and variables.
-   Is a map from strings to the description of the ident *)
-
-type envElement = EFun of funsymb
-                | EVar of binder
-                | EName of funsymb
-
 let glob_table = Hashtbl.create 7
 
 let init_env () =
@@ -310,6 +310,9 @@ let init_env () =
      Hashtbl.add glob_table s (EFun f)) fun_decls;
    !m 
 
+let all_unlocked () =
+  (List.map (fun _ -> None) (! Param.cells))
+
 let clear_var_env () =
   let list_var = ref [] in
   Hashtbl.iter (fun s v ->
@@ -335,6 +338,9 @@ let add_free_name is_pub s =
   freenames := r :: !freenames;
   r
 
+let add_cell name init_value =
+  Param.cells := (! Param.cells) @ [(name, init_value)]
+
 let get_non_interf_name (s,ext) =
    try
      match Hashtbl.find glob_table s  with
@@ -388,7 +394,7 @@ let rec check_ni_term varenv (term,ext) =
 		  FunApp (r, Terms.var_gen (fst r.f_type))
 	    | EFun _ | EVar _ -> internal_error "should not find var/fun here"
 	  with Not_found ->
-	    Var (get_var varenv s)
+	    get_var varenv s
       end
 | (PFunApp ((s,ext) as fi, tlist)) ->
     let f = get_fun fi (List.length tlist) in
@@ -502,38 +508,77 @@ let get_event_fun s arity ext =
     Hashtbl.add event_fun_table s p;
     p
 
-let rec check_process env = function 
-    PNil -> Nil
+let is_unique lst = begin
+  let rec check = begin function
+    | [] -> true
+    | a :: b :: rest when a = b -> false
+    | a :: rest -> check rest
+  end in
+  (check (List.sort compare lst))
+end
+
+let check_cell_list lst = begin
+  if (not (is_unique (List.map fst lst))) then
+    (input_error "cannot name a cell more than once here"
+      (snd (List.hd lst)))
+end
+
+(* locks : extent option list
+   One entry for each cell.
+   None -> cell is not locked by this process
+   Some ext -> cell was locked at ext *)
+let rec check_process env locks = function
+    PNil ->
+      (for i = 1 to (List.length (! Param.cells)) do
+        (match (List.nth locks (i-1)) with
+          | None -> ()
+          | Some ext ->
+              (input_error ("cell " ^ (fst (List.nth (! Param.cells) (i-1)))
+                ^ " is left locked") ext))
+      done);
+      Nil
   | PPar (p1,p2) -> 
-      let p1' = check_process env p1 in
-      let p2' = check_process env p2 in
+      (for i = 1 to (List.length (! Param.cells)) do
+        (match (List.nth locks (i-1)) with
+          | None -> ()
+          | Some ext ->
+              (input_error "cannot have parallel processes inside a lock" ext))
+      done);
+      let p1' = check_process env locks p1 in
+      let p2' = check_process env locks p2 in
       Par(p1', p2')
   | PRepl p -> 
-      Repl(check_process env p, new_occurrence())
+      (for i = 1 to (List.length (! Param.cells)) do
+        (match (List.nth locks (i-1)) with
+          | None -> ()
+          | Some ext ->
+              (input_error "cannot have a replication inside a lock" ext))
+      done);
+      Repl(check_process env locks p, new_occurrence())
   | PTest((f,_),p1,p2) -> 
       let occ' = new_occurrence() in
       begin
 	match f with
 	  PSimpleFact(pred,l) ->
-	    let p1' = check_process env p1 in
-	    let p2' = check_process env p2 in
+	    let p1' = check_process env locks p1 in
+	    let p2' = check_process_implicit_unlock env locks p2 in
 	    let (pred',l') = check_fl_term env (pred,l) in
 	    LetFilter([], Pred(pred',l'), p1', p2', occ')
 	| PSEqual(t1,t2) ->
-	    let p1' = check_process env p1 in
-	    let p2' = check_process env p2 in
+	    let p1' = check_process env locks p1 in
+	    let p2' = check_process_implicit_unlock env locks p2 in
 	    Test(check_term env t1, check_term env t2,
 		 p1', p2', occ')
 	| PSNeq(t1,t2) ->
-	    let p2' = check_process env p2 in
-	    let p1' = check_process env p1 in
+	    let p2' = check_process_implicit_unlock env locks p2 in
+	    let p1' = check_process env locks p1 in
 	    Test(check_term env t1, check_term env t2,
 		 p2', p1', occ')
       end
   | PLetDef (s,ext) ->
       begin
 	try
-          check_process env (Hashtbl.find pdeftbl s)
+          check_process env locks (Hashtbl.find pdeftbl s)
         with Not_found ->
           input_error ("process " ^ s ^ " not defined") ext
       end
@@ -542,21 +587,21 @@ let rec check_process env = function
       Hashtbl.add glob_table s (EName r);
       if (StringMap.mem s env) && (!Param.tulafale != 1) then
 	input_warning ("identifier " ^ s ^ " rebound") ext;
-      Restr(r, check_process (StringMap.add s (EName r) env) p, 
+      Restr(r, check_process (StringMap.add s (EName r) env) locks p, 
 	    new_occurrence())
   | PInput(tc,pat,p) ->
       let (pat',env') = check_pat env pat in
       Input(check_term env tc, pat',
-	    check_process env' p, new_occurrence())
+	    check_process env' locks p, new_occurrence())
   | POutput(tc,t,p) ->
       Output(check_term env tc,
 	     check_term env t,
-	     check_process env p, new_occurrence())
+	     check_process env locks p, new_occurrence())
   | PLet(pat,t,p,p') ->
       let (pat', env') = check_pat env pat in
       let occ' = new_occurrence() in
-      let p1 = check_process env' p in
-      let p1' = check_process env p' in
+      let p1 = check_process env' locks p in
+      let p1' = check_process_implicit_unlock env locks p' in
       Let(pat',check_term env t, p1, p1', occ')
   | PLetFilter(identlist,(f,ext),p,q) ->
       let (env', vlist) = List.fold_left (fun (env, vlist) (s,e) ->
@@ -575,19 +620,103 @@ let rec check_process env = function
 	  Pred(pred',l')
       in
       let occ' = new_occurrence() in
-      let p' = check_process env' p in
-      let q' = check_process env q in
+      let p' = check_process env' locks p in
+      let q' = check_process env locks q in
       LetFilter(vlist, f', p', q', occ')
   | PEvent((i,ext),l,p) ->
       if !Param.key_compromise == 0 then
 	let f = get_event_fun i (List.length l) ext in
-	Event(FunApp(f, List.map (check_term env) l), check_process env p, new_occurrence())
+	Event(FunApp(f, List.map (check_term env) l), check_process env locks p, new_occurrence())
       else
 	let f = get_event_fun i (1+List.length l) ext in
-	Event(FunApp(f, (Terms.new_var_def Param.any_type) :: (List.map (check_term env) l)), check_process env p, new_occurrence())
+	Event(FunApp(f, (Terms.new_var_def Param.any_type) :: (List.map (check_term env) l)), check_process env locks p, new_occurrence())
   | PPhase(n, p) ->
       let occ' = new_occurrence() in
-      Phase(n, check_process env p, occ')
+      Phase(n, check_process env locks p, occ')
+  | PLock(cells, p) ->
+      (check_cell_list cells);
+      Lock(
+        (List.map fst cells),
+        (check_process env
+          (List.map2
+            (fun old_locked (cell_name, _) ->
+              (List.fold_left
+                (fun new_locked (to_lock, ext) ->
+                  if (cell_name = to_lock) then
+                  begin
+                    (match old_locked with
+                      | None -> ()
+                      | Some _ -> (input_error ("cell " ^ cell_name ^ " is already locked") ext));
+                    Some ext
+                  end else
+                    new_locked)
+                old_locked cells))
+            locks (! Param.cells))
+          p))
+  | PUnlock(cells, p) ->
+      (check_cell_list cells);
+      Unlock(
+        (List.map fst cells),
+        (check_process env
+          (List.map2
+            (fun old_locked (cell_name, _) ->
+              (List.fold_left
+                (fun new_locked (to_lock, ext) ->
+                  if (cell_name = to_lock) then
+                  begin
+                    (match old_locked with
+                      | Some _ -> ()
+                      | None -> (input_error ("cell " ^ cell_name ^ " is not locked") ext));
+                    None
+                  end else
+                    new_locked)
+                old_locked cells))
+            locks (! Param.cells))
+          p))
+  | PLockAll(p,ext) ->
+      (for i = 1 to (List.length (! Param.cells)) do
+        (match (List.nth locks (i-1)) with
+          | None -> ()
+          | Some _ ->
+              (input_error ("cell " ^ (fst (List.nth (! Param.cells) (i-1)))
+                ^ " is already locked") ext))
+      done);
+      Lock((List.map fst (! Param.cells)),
+        check_process env (List.map (fun _ -> (Some ext)) locks) p)
+  | PUnlockAll(p,ext) ->
+      (for i = 1 to (List.length (! Param.cells)) do
+        (match (List.nth locks (i-1)) with
+          | None ->
+              (input_error ("cell " ^ (fst (List.nth (! Param.cells) (i-1)))
+                ^ " is not locked") ext)
+          | Some _ -> ())
+      done);
+      Unlock((List.map fst (! Param.cells)),
+        check_process env (List.map (fun _ -> None) locks) p)
+  | PAssign(pairs, p) ->
+      (check_cell_list (List.map fst pairs));
+      Assign(
+        (List.map
+          (fun (cell, term) ->
+            ((fst cell), (check_term env term)))
+          pairs),
+        (check_process env locks p))
+  | PReadAs(pairs, p) ->
+      (check_cell_list (List.map fst pairs));
+      let env' = (ref env) in
+      let pairs' = 
+        (List.map
+          (fun (cell, pattern) ->
+            let (pattern', env'') = (check_pat (! env') pattern) in
+            env' := env'';
+            ((fst cell), pattern'))
+          pairs) in
+      ReadAs(pairs', (check_process (! env') locks p))
+
+(* Handle implicit unlocks in else clauses that are not provided. *)
+and check_process_implicit_unlock env locks = function
+  | PNil -> Nil
+  | p -> (check_process env locks p)
 
 let get_non_interf (id, lopt) =
   (get_non_interf_name id, 
@@ -742,6 +871,11 @@ let rec check_all = function
 	  input_error ("free name " ^ i ^ " already declared") ext;
 	ignore(add_free_name (not b) i)) il;
       check_all l
+  | (Cell (name, init_value)) :: l ->
+      if (List.exists (fun r -> (fst r) = (fst name)) !Param.cells) then
+        input_error ("cell " ^ (fst name) ^ " already declared") (snd name);
+      add_cell (fst name) (check_eq_term (fun _ _ -> ()) glob_table init_value);
+      check_all l
   | (Clauses c) :: l ->
       List.iter check_clause c;
       check_all l
@@ -773,7 +907,7 @@ let rec check_all = function
       end;
       check_all l
   | [Process p] -> 
-      let r = check_process (init_env()) p in
+      let r = check_process (init_env()) (all_unlocked()) p in
       List.iter (List.iter nvn_q) (!query_list);
       List.iter (fun (fact,_,bl) ->
 	nvn_ff fact;
@@ -802,6 +936,8 @@ let rec set_max_used_phase = function
       if n > !Param.max_used_phase then
 	Param.max_used_phase := n;
       set_max_used_phase p
+  | Lock(_,p) | Unlock(_,p)
+  | Assign(_,p) | ReadAs(_,p) -> set_max_used_phase p
 
 let parse_file s = 
   let p = check_all (parse s) in
@@ -961,6 +1097,12 @@ let find_event_arity s e'' arity =
   with Not_found ->
     input_error ("unknown event " ^s) e''
 
+let check_arity predicate expected_arity actual_arity e =
+  let expected_arity' = expected_arity + (List.length !Param.cells) in
+  if actual_arity <> expected_arity' then
+    input_error ("arity of predicate " ^ predicate ^ " should be " ^
+      (string_of_int expected_arity')) e
+
 let check_event ((f,e),n) =
   match f with
     PGNeq(t1,t2) ->
@@ -1000,8 +1142,7 @@ let check_event ((f,e),n) =
 	| _ -> input_error "predicate evinj should have one argument, which is a function application" e'
       end
   | PGSimpleFact(("attacker",_), tl) ->
-      if List.length tl != 1 then
-	input_error "arity of predicate attacker should be 1" e;
+      check_arity "attacker" 1 (List.length tl) e;
       if n > !Param.max_used_phase then
 	begin
 	  input_warning "phase greater than the maximum phase used in the process.\nIs that really what you want?" e;
@@ -1010,8 +1151,7 @@ let check_event ((f,e),n) =
       let att_n = Param.get_pred (Attacker((if n = -1 then (!Param.max_used_phase) else n), Param.any_type)) in
       QFact(att_n, List.map check_query_term tl)
   | PGSimpleFact(("mess",_), tl) ->
-      if List.length tl != 2 then
-	input_error "arity of predicate mess should be 2" e;
+      check_arity "mess" 2 (List.length tl) e;
       if n > !Param.max_used_phase then
 	begin
 	  input_warning "phase greater than the maximum phase used in the process.\nIs that really what you want?" e;
@@ -1353,15 +1493,13 @@ let check_gfact_format ((s, ext), tl, n) =
     "ev" | "evinj" -> 
       input_error "predicates ev and evinj not allowed in nounif" ext
   | "attacker" ->
-      if List.length tl != 1 then
-	input_error "arity of predicate attacker should be 1" ext;
+      (check_arity "attacker" 1 (List.length tl) ext);
       if n > !Param.max_used_phase then
 	input_warning "nounif declaration for a phase greater than used" ext;
       let att_n = Param.get_pred (Attacker((if n = -1 then (!Param.max_used_phase) else n), Param.any_type)) in
       (att_n, List.map check_gformat tl)
   | "mess" ->
-      if List.length tl != 2 then
-	input_error "arity of predicate mess should be 2" ext;
+      (check_arity "mess" 2 (List.length tl) ext);
       if n > !Param.max_used_phase then
 	input_warning "nounif declaration for a phase greater than used" ext;
       let mess_n = Param.get_pred (Mess((if n = -1 then (!Param.max_used_phase) else n), Param.any_type)) in
